<?php
// Convert a path name and a project identifier to a System V IPC key
$key = ftok(dirname(__FILE__) . '/token.php', 'S'); 

// Creating a shared memory segment with a key, we need to use an integer value.
$shmId = shm_attach($key); 
$var_key = 99;

// Obtain a resource semaphore - lock feature. There is nothing wrong if we
// use the same key that is used to obtain a resource shared memory 
$semId = sem_get($key);
echo get_cnt();

/* get counter value */
function get_cnt() {
    global $shmId, $var_key, $semId;

    // Put a lock. There's a caveat. If another process will encounter this lock,
    // it will wait until the lock is removed 
    sem_acquire($semId);

    // Check if we have the requested variables.
    if (shm_has_var($shmId, $var_key)) {
        // If so, read the data
        $val= shm_get_var($shmId, $var_key);
        $val+= 1;
    } else {
        // If the data was not there.
        $val= 1;
    }
    shm_put_var($shmId, $var_key, $val);

    // Releases the lock. 
    sem_release($semId);
    return sprintf("%06d", $val);
}
?>

